#define pinR 3
#define pinG 5
#define pinB 2
#define inputPir A1
#define STEPPER_PIN_1 10
#define STEPPER_PIN_2 8
#define STEPPER_PIN_3 7
#define STEPPER_PIN_4 6
#define SD_pin 4 

#include <SD.h>
#include <TMRpcm.h>

File myFile;
TMRpcm tmrpcm;
bool statePir = false; //if motion was detected or not
int motion = 0;
int step_number = 0;
int motionIntervalStop = 0;
int distanceForwardBackwards = 0;
bool stoppedMusic = false;
void setup() {
  // put your setup code here, to run once:
  tmrpcm.speakerPin = 9;
  Serial.begin(9600);
  pinMode(pinR, OUTPUT);
  pinMode(pinG, OUTPUT);
  pinMode(pinB, OUTPUT);
  pinMode(inputPir, INPUT_PULLUP);
  pinMode(STEPPER_PIN_1, OUTPUT);
  pinMode(STEPPER_PIN_2, OUTPUT);
  pinMode(STEPPER_PIN_3, OUTPUT);
  pinMode(STEPPER_PIN_4, OUTPUT);
  if (!SD.begin(SD_pin)) {
    return;
  }
  tmrpcm.setVolume(5);
}

void loop() {
  // put your main code here, to run repeatedly
  analogWrite(pinR, 23);
  analogWrite(pinG, 252);
  analogWrite(pinB, 3);
  motion = digitalRead(inputPir);
  Serial.println(motion);
  if(motion == HIGH){
    if(statePir == false){
      Serial.println("Motion detected!");
      statePir = true;
      motionIntervalStop = 0;
      if(!tmrpcm.isPlaying()){
         tmrpcm.play("mario.wav");
      }
      if(stoppedMusic == true){
        stoppedMusic = false;
    }
  }
  }else{
    if(statePir == true){
      statePir = false;
      Serial.println("Motion ended!");
    }
    motionIntervalStop = motionIntervalStop + 1;
  }
  if(motionIntervalStop >= 500){
    tmrpcm.stopPlayback();
    stoppedMusic = true;
  }
  Serial.println(motionIntervalStop);
  if(distanceForwardBackwards < 640){
    OneStep(true);
  }else{
    OneStep(false);
    if(distanceForwardBackwards >= 1280){
      distanceForwardBackwards = 0;
    }
  }
  distanceForwardBackwards = distanceForwardBackwards + 1;
  delay(40);
}
void OneStep(bool dir){
    if(dir){
switch(step_number){
  case 0:
  digitalWrite(STEPPER_PIN_1, HIGH);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, LOW);
  break;
  case 1:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, HIGH);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, LOW);
  break;
  case 2:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, HIGH);
  digitalWrite(STEPPER_PIN_4, LOW);
  break;
  case 3:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, HIGH);
  break;
} 
  }else{
    switch(step_number){
  case 0:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, HIGH);
  break;
  case 1:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, HIGH);
  digitalWrite(STEPPER_PIN_4, LOW);
  break;
  case 2:
  digitalWrite(STEPPER_PIN_1, LOW);
  digitalWrite(STEPPER_PIN_2, HIGH);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, LOW);
  break;
  case 3:
  digitalWrite(STEPPER_PIN_1, HIGH);
  digitalWrite(STEPPER_PIN_2, LOW);
  digitalWrite(STEPPER_PIN_3, LOW);
  digitalWrite(STEPPER_PIN_4, LOW);
 
  
} 
  }
step_number++;
  if(step_number > 3){
    step_number = 0;
  }
}
